package com.unis.module.system.enums.area;

import cn.hutool.core.util.ArrayUtil;
import com.unis.framework.common.core.IntArrayValuable;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.Arrays;

/**
 * 行政区划级别枚举
 */
@AllArgsConstructor
@Getter
public enum AreaDeepEnum implements IntArrayValuable {

    PROVINCE(0, "省级"), // 面向 c 端，普通用户
    CITY(1, "市级"), // 面向 c 端，普通用户
    AREA(2, "区(县)级"); // 面向 b 端，管理后台

    public static final int[] ARRAYS = Arrays.stream(values()).mapToInt(AreaDeepEnum::getValue).toArray();

    /**
     * 类型
     */
    private final Integer value;
    /**
     * 类型名
     */
    private final String name;

    public static AreaDeepEnum valueOf(Integer value) {
        return ArrayUtil.firstMatch(areaDeep -> areaDeep.getValue().equals(value), AreaDeepEnum.values());
    }

    @Override
    public int[] array() {
        return ARRAYS;
    }
}
